# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Child
Version:	0.013
Release:	21.%{__distinit}%{__distvers}
Summary:	Object oriented simple interface to fork()
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Child
Source0:	https://cpan.metacpan.org/authors/id/E/EX/EXODIST/Child-%{version}.tar.gz
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(POSIX)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Capture::Tiny) >= 0.31
BuildRequires:	perl(Test::More) >= 0.88
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(POSIX)

%description
Fork is too low level and difficult to manage. Often people forget to exit
at the end, reap their children, and check exit status. The problem is the
low level functions provided to do these things. Throw in pipes for IPC and
you just have a pile of things nobody wants to think about.

%prep
%setup -q -n Child-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/Child.pm
%{perl_vendorlib}/Child/
%{_mandir}/man3/Child.3*
%{_mandir}/man3/Child::IPC::Pipe.3*
%{_mandir}/man3/Child::Link.3*
%{_mandir}/man3/Child::Link::IPC.3*
%{_mandir}/man3/Child::Link::IPC::Pipe.3*
%{_mandir}/man3/Child::Link::IPC::Pipe::Parent.3*
%{_mandir}/man3/Child::Link::IPC::Pipe::Proc.3*
%{_mandir}/man3/Child::Link::Parent.3*
%{_mandir}/man3/Child::Link::Proc.3*
%{_mandir}/man3/Child::Util.3*

%changelog
* Thu Mar  9 2023 Paul Howarth <paul@city-fan.org> - 0.013-21
- Use SPDX-format license tag
- Use %%license unconditionally

* Wed Jun  5 2019 Paul Howarth <paul@city-fan.org> - 0.013-9
- Modernize spec
  - Switch upstream from search.cpan.org to metacpan.org
  - BR: perl-generators unconditionally
  - BR: perl-interpreter rather than perl
  - Don't explicitly clean buildroot in %%install section
  - Drop explicit %%clean section
  - Drop support for building with Test::More < 0.88
  - Drop legacy BuildRoot: and Group: tags

* Thu Jun 23 2016 Paul Howarth <paul@city-fan.org> - 0.013-1
- Update to 0.013
  - Fix Windows
- BR: perl-generators where available
- Simplify find command using -delete
- Update patch for building with Test::More < 0.88

* Tue Jun 30 2015 Paul Howarth <paul@city-fan.org> - 0.012-1
- Update to 0.012
  - Switch to Dist::Zilla
  - Switch to new Changes Layout
  - Fix destructor bug (#12)
- Switch to ExtUtils::MakeMaker flow
- Package upstream's new LICENSE file
- Update patch for building with Test::More < 0.88

* Wed Jun 24 2015 Paul Howarth <paul@city-fan.org> - 0.011-3
- Perl 5.22 rebuild

* Thu Apr  9 2015 Paul Howarth <paul@city-fan.org> - 0.011-1
- Update to 0.011
  - Clean up child processes once they are have been waited on; do not store
    them forever
- Classify buildreqs by usage
- Update patch for building with Test::More < 0.88

* Wed Sep 10 2014 Paul Howarth <paul@city-fan.org> - 0.010-4
- Perl 5.20 rebuild

* Wed Apr 23 2014 Paul Howarth <paul@city-fan.org> - 0.010-1
- Update to 0.010
  - Processes created by fork will have negative pids on Windows
- Update patch for building with Test::More < 0.88
- Drop %%defattr, redundant since rpm 4.4

* Wed Aug 14 2013 Paul Howarth <paul@city-fan.org> - 0.009-8
- Import from Fedora

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.009-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Jul 18 2013 Petr Pisar <ppisar@redhat.com> - 0.009-6
- Perl 5.18 rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.009-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.009-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jun 11 2012 Petr Pisar <ppisar@redhat.com> - 0.009-3
- Perl 5.16 rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.009-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu Aug 11 2011 Iain Arnell <iarnell@gmail.com> 0.009-1
- Specfile autogenerated by cpanspec 1.78
